﻿/*

把监控文件写入到表中

*/

CREATE PROCEDURE [dbo].[USP_Monitor_SSAS]

(
  @FilePath nvarchar(500)='D:\Monitor\Xevent\Monitor_*.xel' --默值
)

AS
BEGIN

    --三天一个复盖
    Delete from Monitor_SSAS where MonitorDate>= DATEADD(D,-3, cast(GETDATE() as date))

	IF OBJECT_ID('tempdb..#tmp') IS NOT NULL DROP TABLE #tmp

	SELECT  cast(dbo.fn_ConvertLocalTime(timestamp_utc) as date) as MonitorDate,   object_name, CAST(event_data AS XML) event_data  INTO #tmp    FROM sys.fn_xe_file_target_read_file  ( @FilePath, default, default, default )
	where object_name in ('QueryEnd')  and cast( dbo.fn_ConvertLocalTime(timestamp_utc) as date)>= DATEADD(D,-3, cast(GETDATE() as date))

	
	    ;with t as (
	    select object_name as EventName,MonitorDate,

		t.event_data.value('(//data[@name="NTUserName"]/value)[1]', 'varchar(20)') as UserName,
		dbo.fn_ConvertLocalTime(t.event_data.value('(//data[@name="StartTime"]/value)[1]', 'datetime') ) as StartTime,
		dbo.fn_ConvertLocalTime(t.event_data.value('(//data[@name="EndTime"]/value)[1]', 'datetime')) as EndTime,
		t.event_data.value('(//data[@name="DatabaseName"]/value)[1]', 'nvarchar(30)') as DatabaseName,
		t.event_data.value('(//data[@name="ServerName"]/value)[1]', 'nvarchar(30)') as ServerName,
		t.event_data.value('(//data[@name="TextData"]/value)[1]', 'nvarchar(max)') as TextData
        from   #tmp t  

		)
		insert into Monitor_SSAS(Duration,eventName,MonitorDate,UserName,StartTime,EndTime,DatabaseName,ServerName,TextData)


		select DATEPART(ss, EndTime-StartTime) as Duration,* from t




END
GO


